<!doctype html>
<html lang="en" xmlns:th="http://www.thymeleaf.org">
<head>
    <base th:href="${#request.getContextPath() + '/'} ">
    <meta charset="utf-8">
    <meta name="renderer" content="webkit">
    <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, minimum-scale=1.0, maximum-scale=1.0, user-scalable=0">
    <link rel="stylesheet" href="assets/fonts/font-awesome/css/font-awesome.css"/>
    <link rel="stylesheet" href="assets/layuiadmin/layui/css/layui.css" media="all">
    <link rel="stylesheet" href="assets/layuiadmin/style/admin.css" media="all">
</head>
<body>
<div class="layui-fluid layui-anim layui-anim-fadein">
    <div class="layui-row">
        <div class="layui-col-md12">
            <div class="layui-card">
                <div class="layui-card-body">
                    <div class="test-table-reload-btn" style="margin-bottom: 10px;">
                        <div class="layui-inline">
                            <input type="text" id="keywords" class="layui-input search-item search-item-width-100" placeholder="输入关键字">
                        </div>
                        <div class="layui-inline layui-form search-item">
                            <select id="type" name="type" lay-filter="typeFilter">
                                <option value="">选择类型</option>
                                <option value="choice">选择题</option>
                                <option value="tureOrFalse">判断题</option>
                                <option value="fillInTheBlanks">填空题</option>
                                <option value="answer">解答题</option>
                            </select>
                        </div>
                        <div id="choiceTypeBox" class="layui-inline layui-form search-item" style="display: none;">
                            <select id="choiceType" name="choiceType">
                                <option value="">选择类型</option>
                                <option value="single">单选</option>
                                <option value="multiple">多选</option>
                            </select>
                        </div>
                        <div class="layui-inline layui-form search-item">
                            <select id="difficulty" name="difficulty" lay-filter="difficultyFilter">
                                <option value="">选择难度</option>
                                <option value="1">⭐</option>
                                <option value="2">⭐⭐</option>
                                <option value="3">⭐⭐⭐</option>
                                <option value="4">⭐⭐⭐⭐</option>
                                <option value="5">⭐⭐⭐⭐⭐</option>
                            </select>
                        </div>
                        <div class="layui-inline">
                            <input type="hidden" id="questionType" readonly style="cursor: pointer;">
                            <input type="text" id="questionTypeName" class="layui-input search-item search-item-width-100" placeholder="试题类型" readonly style="cursor: pointer;">
                        </div>
                        <button type="button" id="search" class="layui-btn layui-btn-sm">
                            <i class="fa fa-lg fa-search"></i> 搜索
                        </button>
                    </div>
                    <table class="layui-hide" id="dataTable" lay-filter="dataTable"></table>
                    <!-- 表头按钮组 -->
                    <script type="text/html" id="headerToolBar">
                        <div class="layui-btn-group">
                            <button type="button" class="layui-btn layui-btn-sm" lay-event="saveEvent">
                                <i class="fa fa-lg fa-plus"></i> 新增
                            </button>
                            <button type="button" class="layui-btn layui-btn-normal layui-btn-sm" lay-event="updateEvent">
                                <i class="fa fa-lg fa-edit"></i> 编辑
                            </button>
                            <button type="button" class="layui-btn layui-btn-danger layui-btn-sm" lay-event="removeEvent">
                                <i class="fa fa-lg fa-trash"></i> 删除
                            </button>
                        </div>
                    </script>
                </div>
            </div>
        </div>
    </div>
</div>
<script src="assets/layuiadmin/layui/layui.js"></script>
<script>
    layui.config({
        base: 'assets/layuiadmin/'
    }).extend({
        index: 'lib/index'
    }).use(['index', 'table', 'laydate', 'common'], function() {
        var $ = layui.$;
        var $win = $(window);
        var table = layui.table;
        var admin = layui.admin;
        var laytpl = layui.laytpl;
        var form = layui.form;
        var laydate = layui.laydate;
        var common = layui.common;
        var form = layui.form;
        var resizeTimeout = null;
        var tableUrl = 'api/question/listpage';

        function getDifficulty(num) {
            var result = '';
            for(var i = 0; i < num; i++) {
                result += '⭐'
            }
            return result;
        }

        // 初始化表格
        function initTable() {
            table.render({
                elem: '#dataTable',
                id: 'dataTable',
                url: top.restAjax.path(tableUrl, []),
                width: admin.screen() > 1 ? '100%' : '',
                height: $win.height() - 90,
                limit: 20,
                limits: [20, 40, 60, 80, 100, 200],
                toolbar: '#headerToolBar',
                request: {
                    pageName: 'page',
                    limitName: 'rows'
                },
                cols: [
                    [
                        {type:'checkbox', fixed: 'left'},
                        {field:'rowNum', width:80, title: '序号', fixed: 'left', align:'center', templet: '<span>{{d.LAY_INDEX}}</span>'},
                        {field: 'subject', width: 400, title: '题目', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                return rowData;
                            }
                        },
                        {field: 'questionTypeName', width: 140, title: '试题类型', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                return rowData;
                            }
                        },
                        {field: 'type', width: 150, title: '种类', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                if(rowData == 'choice') {
                                    return '选择题';
                                } else if(rowData == 'tureOrFalse') {
                                    return '判断题';
                                } else if(rowData == 'fillInTheBlanks') {
                                    return '填空题';
                                } else if(rowData == 'answer') {
                                    return '解答题';
                                }
                                return rowData;
                            }
                        },
                        {field: 'choiceType', width: 100, title: '选择类别', align:'center',
                            templet: function(row) {
                                if(row.type != 'choice') {
                                    return '-';
                                }
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                if(rowData == 'single') {
                                    return '单选';
                                } else if(rowData == 'multiple') {
                                    return '多选';
                                }
                                return rowData;
                            }
                        },
                        {field: 'difficulty', width: 150, title: '难度', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                return getDifficulty(rowData);
                            }
                        },
                        {field: 'source', width: 150, title: '来源', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                return rowData;
                            }
                        },
                        {field: 'gmtCreate', width: 180, title: '添加时间', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                return rowData;
                            }
                        },
                        {field: 'getQuestion', width: 100, title: '详情', fixed: 'right', align:'center', exportType: 'text',
                            templet: function(row) {
                                return '<button class="layui-btn layui-btn layui-btn-sm layui-btn-normal" lay-event="getQuestionEvent"><i class="fa fa-search"></i> 查看</button>';
                            }
                        },
                    ]
                ],
                page: true,
                parseData: function(data) {
                    var rows = [];
                    if($('#usedStatus').val() == 'used') {
                        for(var i = 0, item; item = data.rows[i++];) {
                            if(item.used) {
                                rows.push(item);
                            }
                        }
                    } else if($('#usedStatus').val() == 'unUsed') {
                        for(var i = 0, item; item = data.rows[i++];) {
                            if(!item.used) {
                                rows.push(item);
                            }
                        }
                    } else {
                        rows = data.rows;
                    }
                    return {
                        'code': 0,
                        'msg': '',
                        'count': data.total,
                        'data': rows
                    };
                }
            });
        }
        // 重载表格
        function reloadTable(currentPage) {
            table.reload('dataTable', {
                url: top.restAjax.path(tableUrl, []),
                where: {
                    keywords: $('#keywords').val(),
                    type: $('#type').val(),
                    choiceType: $('#choiceType').val(),
                    questionType: $('#questionType').val(),
                    difficulty: $('#difficulty').val()
                },
                page: {
                    curr: currentPage
                },
            });
        }
        // 初始化日期
        function initDate() {
            // 日期选择
            laydate.render({
                elem: '#startTime',
                format: 'yyyy-MM-dd'
            });
            laydate.render({
                elem: '#endTime',
                format: 'yyyy-MM-dd'
            });
        }
        // 删除
        function removeData(ids) {
            top.dialog.msg(top.dataMessage.delete, {
                time: 0,
                btn: [top.dataMessage.button.yes, top.dataMessage.button.no],
                shade: 0.3,
                yes: function (index) {
                    top.dialog.close(index);
                    var layIndex;
                    top.restAjax.delete(top.restAjax.path('api/question/remove/{ids}', [ids]), {}, null, function (code, data) {
                        top.dialog.msg(top.dataMessage.deleteSuccess, {time: 1000});
                        reloadTable();
                    }, function (code, data) {
                        top.dialog.msg(data.msg);
                    }, function () {
                        layIndex = top.dialog.msg(top.dataMessage.deleting, {icon: 16, time: 0, shade: 0.3});
                    }, function () {
                        top.dialog.close(layIndex);
                    });
                }
            });
        }
        initTable();
        initDate();
        // 事件 - 页面变化
        $win.on('resize', function() {
            clearTimeout(resizeTimeout);
            resizeTimeout = setTimeout(function() {
                reloadTable();
            }, 500);
        });
        // 事件 - 搜索
        $(document).on('click', '#search', function() {
            reloadTable(1);
        });
        // 事件 - 增删改
        table.on('toolbar(dataTable)', function(obj) {
            var layEvent = obj.event;
            var checkStatus = table.checkStatus('dataTable');
            var checkDatas = checkStatus.data;
            if(layEvent === 'saveEvent') {
                layer.open({
                    type: 2,
                    title: false,
                    closeBtn: 0,
                    area: ['100%', '100%'],
                    shadeClose: true,
                    anim: 2,
                    content: top.restAjax.path('route/question/save', []),
                    end: function() {
                        reloadTable();
                    }
                });
            } else if(layEvent === 'updateEvent') {
                if(checkDatas.length === 0) {
                    top.dialog.msg(top.dataMessage.table.selectEdit);
                } else if(checkDatas.length > 1) {
                    top.dialog.msg(top.dataMessage.table.selectOneEdit);
                } else {
                    layer.open({
                        type: 2,
                        title: false,
                        closeBtn: 0,
                        area: ['100%', '100%'],
                        shadeClose: true,
                        anim: 2,
                        content: top.restAjax.path('route/question/update?questionId={questionId}', [checkDatas[0].questionId]),
                        end: function() {
                            reloadTable();
                        }
                    });
                }
            } else if(layEvent === 'removeEvent') {
                if(checkDatas.length === 0) {
                    top.dialog.msg(top.dataMessage.table.selectDelete);
                } else {
                    var ids = '';
                    for(var i = 0, item; item = checkDatas[i++];) {
                        if(i > 1) {
                            ids += '_';
                        }
                        ids += item['questionId'];
                    }
                    removeData(ids);
                }
            }
        });

        table.on('tool(dataTable)', function(obj) {
            var data = obj.data;
            var event = obj.event;
            if(event === 'getQuestionEvent') {
                top.dialog.open({
                    url: top.restAjax.path('route/question/get?questionId={questionId}', [data.questionId]),
                    title: '查看试题，难度：' + getDifficulty(data.difficulty),
                    width: '500px',
                    height: '80%',
                    onClose: function () {
                    }
                });
            } else if(event === 'examinationPagerEvent') {
                top.dialog.open({
                    url: top.restAjax.path('route/question/get?questionId={questionId}', [data.questionId]),
                    title: '查看试卷',
                    width: '500px',
                    height: '80%',
                    onClose: function() {
                    }
                });
            }
        })

        form.on('select(typeFilter)', function(data){
            $('#choiceType').val('')
            form.render('select');
            if(data.value === 'choice') {
                $('#choiceTypeBox').show();
            } else {
                $('#choiceTypeBox').hide();
            }
        });

        $('#questionTypeName').on('click', function() {
            top.dialog.open({
                url: top.restAjax.path('route/question-type/list-tree-select?questionTypeIds={questionTypeIds}', [$('#questionType').val()]),
                title: '选择自定义类型',
                width: '200px',
                height: '400px',
                onClose: function() {
                    var selectedNodes = top.dialog.dialogData.selectedNodes;
                    if(selectedNodes.length > 0) {
                        var questionType = '';
                        var questionTypeName = '';
                        for(var i = 0, item; item = selectedNodes[i++];) {
                            if(questionType.length > 0) {
                                questionType += ',';
                                questionTypeName += ',';
                            }
                            questionType += item.id;
                            questionTypeName += item.name;
                        }
                        $('#questionType').val(questionType);
                        $('#questionTypeName').val(questionTypeName);
                    } else {
                        $('#questionType').val('');
                        $('#questionTypeName').val('');
                    }
                }
            });
        });

        form.on('select(usedStatusFilter)', function(data) {
            reloadTable();
        });
    });
</script>
</body>
</html>